#pragma once
#include <feos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/** @file coopgui.h
 *  \brief Main Cooperative GUI API header file.
 */

/** @addtogroup coopgui Cooperative GUI
 *  @brief FeOS Cooperative GUI API.
 *  @code
 *  #include <coopgui.h>
 *  @endcode
 *  @{
 */

#include "coopgui/base.h"
#include "coopgui/video.h"
#include "coopgui/resptr.h"
#include "coopgui/touchpos.h"
#include "coopgui/grf.h"
#include "coopgui/font.h"
#include "coopgui/fileicon.h"
#include "coopgui/keyboard.h"
#include "coopgui/application.h"
#include "coopgui/guimanager.h"
#include "coopgui/appimpl.h"

/** @} */
